// Mesure de distance par HC-SR04

#define TRIGGER 4 // broche pin trigger
#define ECHO 5 // broche pin echo

int duree;    // entier pour la durée en microsecondes
int distance; // entier pour la distance en cm

void setup() {
pinMode(TRIGGER,OUTPUT);    // pin trigger définie en sortie
pinMode(ECHO, INPUT);       // pin écho définie en entrée
digitalWrite(TRIGGER, LOW); // RAZ pin trigger 

Serial.begin(9600); // initialisation liason série pour affichage mesure

}

void loop() {
// sortie trigger: impulsion de 10µs 
digitalWrite(TRIGGER, HIGH);
delayMicroseconds(10);
digitalWrite(TRIGGER, LOW);

// acquisition de la durée de l'impulsion 
duree = pulseIn(ECHO, HIGH);
// calcul de la distance : 343 m/s 343/1000000 m/µs = (343 * 100)/1000000 cm/µs 
distance = (duree * 0.0343) / 2; //divisée par 2 pour Aller/Retour

// Affichage durée et distance
Serial.print("Durée = ");
Serial.print(duree);
Serial.print(" µs => ");
Serial.print("distance = ");
Serial.print(distance);
Serial.println(" cm"); 

delay(500);
}